# coding: utf-8

"""
    UbiOps

    Client Library to interact with the UbiOps API.  # noqa: E501

    The version of the OpenAPI document: v2.1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ubiops.configuration import Configuration


class PipelineObjectList(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'name': 'str',
        'reference_type': 'str',
        'reference_name': 'str',
        'version': 'str',
        'input_type': 'str',
        'output_type': 'str',
        'input_fields': 'list[ModelInputFieldList]',
        'output_fields': 'list[ModelOutputFieldList]'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'reference_type': 'reference_type',
        'reference_name': 'reference_name',
        'version': 'version',
        'input_type': 'input_type',
        'output_type': 'output_type',
        'input_fields': 'input_fields',
        'output_fields': 'output_fields'
    }

    def __init__(self, id=None, name=None, reference_type=None, reference_name=None, version=None, input_type=None, output_type=None, input_fields=None, output_fields=None, local_vars_configuration=None):  # noqa: E501
        """PipelineObjectList - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._name = None
        self._reference_type = None
        self._reference_name = None
        self._version = None
        self._input_type = None
        self._output_type = None
        self._input_fields = None
        self._output_fields = None
        self.discriminator = None

        self.id = id
        self.name = name
        self.reference_type = reference_type
        self.reference_name = reference_name
        if version is not None:
            self.version = version
        if input_type is not None:
            self.input_type = input_type
        if output_type is not None:
            self.output_type = output_type
        if input_fields is not None:
            self.input_fields = input_fields
        if output_fields is not None:
            self.output_fields = output_fields

    @property
    def id(self):
        """Gets the id of this PipelineObjectList.  # noqa: E501


        :return: The id of this PipelineObjectList.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PipelineObjectList.


        :param id: The id of this PipelineObjectList.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this PipelineObjectList.  # noqa: E501


        :return: The name of this PipelineObjectList.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PipelineObjectList.


        :param name: The name of this PipelineObjectList.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    @property
    def reference_type(self):
        """Gets the reference_type of this PipelineObjectList.  # noqa: E501


        :return: The reference_type of this PipelineObjectList.  # noqa: E501
        :rtype: str
        """
        return self._reference_type

    @reference_type.setter
    def reference_type(self, reference_type):
        """Sets the reference_type of this PipelineObjectList.


        :param reference_type: The reference_type of this PipelineObjectList.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and reference_type is None:  # noqa: E501
            raise ValueError("Invalid value for `reference_type`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                reference_type is not None and len(reference_type) < 1):
            raise ValueError("Invalid value for `reference_type`, length must be greater than or equal to `1`")  # noqa: E501

        self._reference_type = reference_type

    @property
    def reference_name(self):
        """Gets the reference_name of this PipelineObjectList.  # noqa: E501


        :return: The reference_name of this PipelineObjectList.  # noqa: E501
        :rtype: str
        """
        return self._reference_name

    @reference_name.setter
    def reference_name(self, reference_name):
        """Sets the reference_name of this PipelineObjectList.


        :param reference_name: The reference_name of this PipelineObjectList.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and reference_name is None:  # noqa: E501
            raise ValueError("Invalid value for `reference_name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                reference_name is not None and len(reference_name) < 1):
            raise ValueError("Invalid value for `reference_name`, length must be greater than or equal to `1`")  # noqa: E501

        self._reference_name = reference_name

    @property
    def version(self):
        """Gets the version of this PipelineObjectList.  # noqa: E501


        :return: The version of this PipelineObjectList.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this PipelineObjectList.


        :param version: The version of this PipelineObjectList.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                version is not None and len(version) < 1):
            raise ValueError("Invalid value for `version`, length must be greater than or equal to `1`")  # noqa: E501

        self._version = version

    @property
    def input_type(self):
        """Gets the input_type of this PipelineObjectList.  # noqa: E501


        :return: The input_type of this PipelineObjectList.  # noqa: E501
        :rtype: str
        """
        return self._input_type

    @input_type.setter
    def input_type(self, input_type):
        """Sets the input_type of this PipelineObjectList.


        :param input_type: The input_type of this PipelineObjectList.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                input_type is not None and len(input_type) < 1):
            raise ValueError("Invalid value for `input_type`, length must be greater than or equal to `1`")  # noqa: E501

        self._input_type = input_type

    @property
    def output_type(self):
        """Gets the output_type of this PipelineObjectList.  # noqa: E501


        :return: The output_type of this PipelineObjectList.  # noqa: E501
        :rtype: str
        """
        return self._output_type

    @output_type.setter
    def output_type(self, output_type):
        """Sets the output_type of this PipelineObjectList.


        :param output_type: The output_type of this PipelineObjectList.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                output_type is not None and len(output_type) < 1):
            raise ValueError("Invalid value for `output_type`, length must be greater than or equal to `1`")  # noqa: E501

        self._output_type = output_type

    @property
    def input_fields(self):
        """Gets the input_fields of this PipelineObjectList.  # noqa: E501


        :return: The input_fields of this PipelineObjectList.  # noqa: E501
        :rtype: list[ModelInputFieldList]
        """
        return self._input_fields

    @input_fields.setter
    def input_fields(self, input_fields):
        """Sets the input_fields of this PipelineObjectList.


        :param input_fields: The input_fields of this PipelineObjectList.  # noqa: E501
        :type: list[ModelInputFieldList]
        """

        self._input_fields = input_fields

    @property
    def output_fields(self):
        """Gets the output_fields of this PipelineObjectList.  # noqa: E501


        :return: The output_fields of this PipelineObjectList.  # noqa: E501
        :rtype: list[ModelOutputFieldList]
        """
        return self._output_fields

    @output_fields.setter
    def output_fields(self, output_fields):
        """Sets the output_fields of this PipelineObjectList.


        :param output_fields: The output_fields of this PipelineObjectList.  # noqa: E501
        :type: list[ModelOutputFieldList]
        """

        self._output_fields = output_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PipelineObjectList):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PipelineObjectList):
            return True

        return self.to_dict() != other.to_dict()
